﻿local _G = _G
local CM = ChatMonitor
CM.LS = LibStub
CM.L = CM.LS("AceLocale-3.0"):GetLocale("ChatMonitor")
CM.LSM = CM.LS("LibSharedMedia-3.0")
CM.AT = CM.LS("AceTimer-3.0")
local L = CM.L

CM.timeformats = {
	f1 = "(12) %I:%M", 
	f2 = "(12) %I:%M:%S", 
	f3 = "(12) %I:%M %p", 
	f4 = "(12) %I:%M:%S %p", 
	f5 = "(24) %H:%M", 
	f6 = "(24) %H:%M:%S"
}

CM.defaults = {
	char = {
		wtb = false, lfg = false, wts = true, js = false, enc = false,
		lw = false, ins = false, tlr = false, bs = false, alc = false,
		eng = false, custom = false, changeneral = false, chantrade = true,
		changuild = false, chanlfg = false, chancustom = false,
		deathknight = false, warrior = false, rogue = false, mage = false,
		priest = false, hunter = false, warlock = false, demonhunter = false,
		shaman = false, druid = false, monk = false, paladin = false, lfm = false,
		heal = false, dps = false, mel = false, rng = false, cc = false, tank = false,
		guild = false, lfgc = false, cus = false, enabled = true, lfguild = false,
	},
	profile = {
		font = "Friz Quadrata TT", fontsize = 10, timestampcolour = "ffffd200",
		playercolour = "ff22ee55", backdropbackground = "80000000",
		backdropborder = "ff87bdff", generalcolour = "ffffffff",
		alccolour = "ffffffff", bscolour = "ffffffff", enccolour = "ffffffff",
		engcolour = "ffffffff", inscolour = "ffffffff", jscolour = "ffffffff",
		lwcolour = "ffffffff", tlrcolour = "ffffffff",
		alcsound = "None", bssound = "None", encsound = "None",
		engsound = "None", inssound = "None", jssound = "None",
		lwsound = "None", tlrsound = "None",
		deathknightcolour = "ffffffff", warriorcolour = "ffffffff", roguecolour = "ffffffff",
		magecolour = "ffffffff", priestcolour = "ffffffff", huntercolour = "ffffffff",
		warlockcolour = "ffffffff", demonhuntercolour = "ffffffff", shamancolour = "ffffffff",
		druidcolour = "ffffffff", monkcolour = "ffffffff", paladincolour = "ffffffff",
		deathknightsound = "None", warriorsound = "None", roguesound = "None",
		magesound = "None", priestsound = "None", huntersound = "None",
		warlocksound = "None", demonhuntersound = "None", shamansound = "None",
		druidsound = "None", monksound = "None", paladinsound = "None",
		useclasscolours = true, posx = (UIParent:GetWidth() - 575) / 2,
		posy = (UIParent:GetHeight() - 100) / 2, width = 575, height = 100, soundon = true,
		alertsound = "Mouse click", maxdistance = 2,
		wtblist = L["WTB"], lfglist = L["LFG"], wtslist = L["WTS"], 
		jslist = L["JC"], enclist = L["ENC"], lwist = L["LW"],
		inslist = L["INS"], tlrlist = L["TLR"], bslist = L["BS"],
		alclist = L["ALC"], englist = L["ENG"], customlist = {},
		deathknightlist = L["DEATHKNIGHT"], warriorlist = L["WARRIOR"], roguelist = L["ROGUE"],
		magelist = L["MAGE"], priestlist = L["PRIEST"], hunterlist = L["HUNTER"],
		warlocklist = L["WARLOCK"], demonhunterlist = L["DEMONHUNTER"], shamanlist = L["SHAMAN"],
		druidlist = L["DRUID"], monklist = L["MONK"], paladinlist = L["PALADIN"],
		healcolour = "ffffffff", dpscolour = "ffffffff", melcolour = "ffffffff", 
		rngcolour = "ffffffff", cccolour = "ffffffff", tankcolour = "ffffffff",
		healsound = "None", dpssound = "None", melsound = "None", rngsound = "None", 
		ccsound = "None", tanksound = "None",
		heallist = L["HEAL"], dpslist = L["DPS"], mellist = L["MEL"], rnglist = L["RNG"], 
		cclist = L["CC"], tanklist = L["TANK"],
		wtscolour = "ffffffff", wtssound = "None", wtslist = L["WTS"],
		wtbcolour = "ffffffff", wtbsound = "None", wtblist = L["WTB"],
		guildcolour = "ffffffff", guildsound = "None", guildlist = L["GUILD"],
		lfgccolour = "ffffffff", lfgcsound = "None", lfgclist = L["LFG"],
		cuscolour = "ffffffff", cussound = "None", cuslist = "",
		showts = true, tsformat = "f5", hidescroll = false, tradeonly = true,
		fadetime = 300, lfguildcolour = "ffffffff", lfguildsound = "None",
		lfguildlist = L["LFGUILD"],lfmcolour = "ffffffff", lfmsound = "None",
		lfmlist = L["LFM"],
	},
}

--[[
CM.timestamps = {
	[1] = {name = L["12h h:m"], timeformat = "%I:%M"},
	[2] = {name = L["12h h:m:s"], timeformat = "%I:%M:%S"},
	[3] = {name = L["12h h:m am/pm"], timeformat = "%I:%M %p"},
	[4] = {name = L["12h h:m:s am/pm"], timeformat = "%I:%M:%S %p"},
	[5] = {name = L["24h h:m"], timeformat = "%H:%M"},
	[6] = {name = L["24h h:m:s"], timeformat = "%H:%M:%S"},
}
]]--

CM.CustomSounds = {
	{name="Applause",desc="Applause"},
	{name="Bark",desc="Dog barking"},
	{name="Beeps",desc="Digital beeps"},
	{name="Bell",desc="Bell"},
	{name="Cancel",desc="Cancel"},
	{name="Chime",desc="Chime"},
	{name="CreepyNoise",desc="Creepy noise"},
	{name="Click",desc="Click"},
	{name="Fart",desc="Fart"},
	{name="Heart",desc="Heart"},
	{name="IM",desc="IM"},
	{name="Info",desc="Info"},
	{name="Kachink",desc="Kachink"},
	{name="Link",desc="Link"},
	{name="Menu",desc="Menu"},
	{name="Metal_Hit",desc="Metal hit"},
	{name="Mouse Click",desc="Mouse click"},
	{name="Oddbounce",desc="Odd bounce"},
	{name="Ping-ding",desc="Ping ding"},
	{name="Powerup",desc="Powerup"},
	{name="Stapler",desc="Stapler"},
	{name="Text1",desc="Text1"},
	{name="Text2",desc="Text2"},
	{name="TextboxBloop",desc="Textbox Bloop"},
	{name="Thip",desc="Thip"},
	{name="Xylo",desc="Xylo"},
}

CM.TimeSinceLastUpdate = 0
CM.UpdateInterval = 0.5
CM.History = {}
CM.HIndex = 1
CM.frame.flashtimer = 0
CM.frame:RegisterEvent("ADDON_LOADED")
CM.frame:RegisterEvent("PLAYER_LOGIN")
CM.frame:SetScript("OnEvent", function(...) CM:eventhandler(...) end)